Index: branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/CONFIG/SHARED/field_def_bgc.xml
===================================================================
--- branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/CONFIG/SHARED/field_def_bgc.xml	(revision 7254)
+++ branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/CONFIG/SHARED/field_def_bgc.xml	(revision 7271)
@@ -426,7 +426,12 @@
        <field id= "INTDISSIN"  long_name="Dissolved Inorganic Nitrogen Content"      unit="mmolN/m2"    />
        <field id= "INTDISSISI" long_name="Dissolved Inorganic Silicon Content"       unit="mmolSi/m2"   />
-       <field id= "INTTALK"     long_name="Dissolved Alkalinity Content"              unit="meq/m2"      />
+       <field id= "INTTALK"    long_name="Dissolved Alkalinity Content"              unit="meq/m2"      />
        <field id= "O2min"      long_name="Oxygen Minimum Concentration"              unit="mmolO2/m3"   />
        <field id= "ZO2min"     long_name="Depth of Oxygen Minimum Concentration"     unit="m"           />
+       <field id= "FBDDTALK"   long_name="Int. change of Alkalinity due to Biology"  unit="meq/m2/d"    />
+       <field id= "FBDDTDIC"   long_name="Int. change of DI Carbon due to Biology"   unit="mmolC/m2/d"  />
+       <field id= "FBDDTIFE"   long_name="Int. change of DI Iron due to Biology"     unit="mmolFe/m2/d" />
+       <field id= "FBDDTDIN"   long_name="Int. change of DI Nitrogen due to Biology" unit="mmolN/m2/d"  />
+       <field id= "FBDDTDISI"  long_name="Int. change of DI Silicon due to Biology"  unit="mmolSi/m2/d" />
 
        <!-- MEDUSA 3D diagnostics -->
@@ -441,5 +446,5 @@
        <field id= "BDDTALK3"   long_name="Change of Alkalinity due to Biology"       unit="meq/m3/d"      grid_ref="grid_T_3D"  />
        <field id= "BDDTDIC3"   long_name="Change of DI Carbon due to Biology"        unit="mmolC/m3/d"    grid_ref="grid_T_3D"  />
-       <field id= "BDDTDIFE3"   long_name="Change of DI Iron due to Biology"          unit="mmolFe/m3/d"   grid_ref="grid_T_3D"  />
+       <field id= "BDDTDIFE3"  long_name="Change of DI Iron due to Biology"          unit="mmolFe/m3/d"   grid_ref="grid_T_3D"  />
        <field id= "BDDTDIN3"   long_name="Change of DI Nitrogen due to Biology"      unit="mmolN/m3/d"    grid_ref="grid_T_3D"  />
        <field id= "BDDTDISI3"  long_name="Change of DI Silicon due to Biology"       unit="mmolSi/m3/d"   grid_ref="grid_T_3D"  />
@@ -741,4 +746,9 @@
       <field field_ref= "O2min"      name="O2min"      />
       <field field_ref= "ZO2min"     name="ZO2min"     />
+      <field field_ref= "FBDDTALK"   name="FBDDTALK"   />
+      <field field_ref= "FBDDTDIC"   name="FBDDTDIC"   />
+      <field field_ref= "FBDDTDIFE"  name="FBDDTDIFE"  />
+      <field field_ref= "FBDDTDIN"   name="FBDDTDIN"   />
+      <field field_ref= "FBDDTDISI"  name="FBDDTDISI"  />
       <field field_ref= "TPPD3"      name="TPPD3"      />
       <field field_ref= "BDDTALK3"   name="BDDTALK3"   />
Index: branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90
===================================================================
--- branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 7254)
+++ branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 7271)
@@ -381,4 +381,5 @@
       !! 2D var for new CMIP6 diagnostics (behind a key_roam ifdef for simplicity)
       REAL(wp), POINTER, DIMENSION(:,:  ) :: fgco2, intdissic, intdissin, intdissisi, inttalk, o2min, zo2min
+      REAL(wp), POINTER, DIMENSION(:,:, ) :: fbddtalk, fbddtdic, fbddtdife, fbddtdin, fbddtdisi
       !!
       !! 3D var for new CMIP6 diagnostics
@@ -1030,4 +1031,24 @@
              zo2min(:,:)  = 0.0 !!
           ENDIF          
+          IF( med_diag%FBDDTALK%dgsave  ) THEN
+             CALL wrk_alloc( jpi, jpj, fbddtalk  )
+             fbddtalk(:,:)  = 0.0 !! 
+          ENDIF
+          IF( med_diag%FBDDTDIC%dgsave  ) THEN
+             CALL wrk_alloc( jpi, jpj, fbddtdic  )
+             fbddtdic(:,:)  = 0.0 !! 
+          ENDIF
+          IF( med_diag%FBDDTDIFE%dgsave ) THEN
+             CALL wrk_alloc( jpi, jpj, fbddtdife )
+             fbddtdife(:,:) = 0.0 !! 
+          ENDIF
+          IF( med_diag%FBDDTDIN%dgsave  ) THEN
+             CALL wrk_alloc( jpi, jpj, fbddtdin  )
+             fbddtdin(:,:)  = 0.0 !! 
+          ENDIF
+          IF( med_diag%FBDDTDISI%dgsave ) THEN
+             CALL wrk_alloc( jpi, jpj, fbddtdisi )
+             fbddtdisi(:,:) = 0.0 !! 
+          ENDIF
           !! 
           !! AXY (10/11/16): CMIP6 diagnostics, 3D
@@ -3803,9 +3824,25 @@
                endif               
 
-               !! AXY (09/11/16): CMIP6 diagnostics
-               IF( med_diag%BDDTALK3%dgsave ) THEN
+               !! AXY (18/11/16): CMIP6 diagnostics
+               IF( med_diag%FBDDTALK%dgsave )  THEN
+                  fbddtalk(ji,jj)  =  fbddtalk(ji,jj)  + (btra(jpalk) * fthk)
+               ENDIF
+               IF( med_diag%FBDDTDIC%dgsave )  THEN
+                  fbddtdic(ji,jj)  =  fbddtdic(ji,jj)  + (btra(jpdic) * fthk)
+               ENDIF
+               IF( med_diag%FBDDTDIFE%dgsave ) THEN
+                  fbddtdife(ji,jj) =  fbddtdife(ji,jj) + (btra(jpfer) * fthk)
+               ENDIF
+               IF( med_diag%FBDDTDIN%dgsave )  THEN
+                  fbddtdin(ji,jj)  =  fbddtdin(ji,jj)  + (btra(jpdin) * fthk)
+               ENDIF
+               IF( med_diag%FBDDTDISI%dgsave ) THEN
+                  fbddtdisi(ji,jj) =  fbddtdisi(ji,jj) + (btra(jpsil) * fthk)
+               ENDIF
+	       !!
+               IF( med_diag%BDDTALK3%dgsave )  THEN
                   bddtalk3(ji,jj,jk)  =  btra(jpalk)
                ENDIF
-               IF( med_diag%BDDTDIC3%dgsave ) THEN
+               IF( med_diag%BDDTDIC3%dgsave )  THEN
                   bddtdic3(ji,jj,jk)  =  btra(jpdic)
                ENDIF
@@ -3813,5 +3850,5 @@
                   bddtdife3(ji,jj,jk) =  btra(jpfer)
                ENDIF
-               IF( med_diag%BDDTDIN3%dgsave ) THEN
+               IF( med_diag%BDDTDIN3%dgsave )  THEN
                   bddtdin3(ji,jj,jk)  =  btra(jpdin)
                ENDIF
@@ -5792,4 +5829,24 @@
              CALL wrk_dealloc( jpi, jpj, zo2min      )
           ENDIF          
+          IF( med_diag%FBDDTALK%dgsave ) THEN
+             CALL iom_put( "FBDDTALK"  , fbddtalk   )
+             CALL wrk_dealloc( jpi, jpj, fbddtalk   )
+          ENDIF          
+          IF( med_diag%FBDDTDIC%dgsave ) THEN
+             CALL iom_put( "FBDDTDIC"  , fbddtdic   )
+             CALL wrk_dealloc( jpi, jpj, fbddtdic   )
+          ENDIF          
+          IF( med_diag%FBDDTDIFE%dgsave ) THEN
+             CALL iom_put( "FBDDTDIFE" , fbddtdife  )
+             CALL wrk_dealloc( jpi, jpj, fbddtdife  )
+          ENDIF          
+          IF( med_diag%FBDDTDIN%dgsave ) THEN
+             CALL iom_put( "FBDDTDIN"  , fbddtdin   )
+             CALL wrk_dealloc( jpi, jpj, fbddtdin   )
+          ENDIF          
+          IF( med_diag%FBDDTDISI%dgsave ) THEN
+             CALL iom_put( "FBDDTDISI" , fbddtdisi  )
+             CALL wrk_dealloc( jpi, jpj, fbddtdisi  )
+          ENDIF    
           !!
           !! AXY (09/11/16): 3D CMIP6 diagnostics
Index: branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcnam_medusa.F90
===================================================================
--- branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcnam_medusa.F90	(revision 7254)
+++ branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcnam_medusa.F90	(revision 7271)
@@ -2184,4 +2184,24 @@
           med_diag%ZO2min%dgsave = .FALSE.
       ENDIF
+      IF  (iom_use("FBDDTALK")) THEN 
+          med_diag%FBDDTALK%dgsave = .TRUE.
+      ELSE 
+          med_diag%FBDDTALK%dgsave = .FALSE.
+      ENDIF
+      IF  (iom_use("FBDDTDIC")) THEN 
+          med_diag%FBDDTDIC%dgsave = .TRUE.
+      ELSE 
+          med_diag%FBDDTDIC%dgsave = .FALSE.
+      ENDIF
+      IF  (iom_use("FBDDTDIFE")) THEN 
+          med_diag%FBDDTDIFE%dgsave = .TRUE.
+      ELSE 
+          med_diag%FBDDTDIFE%dgsave = .FALSE.
+      ENDIF
+      IF  (iom_use("FBDDTDISI")) THEN 
+          med_diag%FBDDTDISI%dgsave = .TRUE.
+      ELSE 
+          med_diag%FBDDTDISI%dgsave = .FALSE.
+      ENDIF
       !!
       !! 3D
Index: branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/trc.F90
===================================================================
--- branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/trc.F90	(revision 7254)
+++ branches/NERC/dev_r5518_NOC_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/trc.F90	(revision 7271)
@@ -136,4 +136,5 @@
                   epC100, epCALC100, epN100, epSI100,                                                &
                   FGCO2, INTDISSIC, INTDISSIN, INTDISSISI, INTTALK, O2min, ZO2min,                   &
+                  FBDDTALK, FBDDTDIC, FBDDTDIFE, FBDDTDIN, FBDDTDISI,                                & 
 ! AXY (11/11/16): additional CMIP6 3D diagnostics
                   TPPD3,                                                                             &