Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/LIM_SRC_2/limdyn_2.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/LIM_SRC_2/limdyn_2.F90	(revision 7291)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/LIM_SRC_2/limdyn_2.F90	(revision 7298)
@@ -87,5 +87,5 @@
          ! ---------------------------------------------------
          
-         IF( lk_mpp .OR. lk_mpp_rep ) THEN                    ! mpp: compute over the whole domain
+         IF( lk_mpp ) THEN                    ! mpp: compute over the whole domain
             i_j1 = 1   
             i_jpj = jpj
Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/LIM_SRC_3/limdyn.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/LIM_SRC_3/limdyn.F90	(revision 7291)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/LIM_SRC_3/limdyn.F90	(revision 7298)
@@ -94,5 +94,5 @@
          ! ---------------------------------------------------
 
-         IF( lk_mpp .OR. lk_mpp_rep ) THEN                    ! mpp: compute over the whole domain
+         IF( lk_mpp ) THEN                    ! mpp: compute over the whole domain
             i_j1 = 1
             i_jpj = jpj
Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/DIA/diahsb.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/DIA/diahsb.F90	(revision 7291)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/DIA/diahsb.F90	(revision 7298)
@@ -372,8 +372,4 @@
 
       IF( .NOT. ln_diahsb )   RETURN
-         !      IF( .NOT. lk_mpp_rep ) &
-         !        CALL ctl_stop (' Your global mpp_sum if performed in single precision - 64 bits -', &
-         !             &         ' whereas the global sum to be precise must be done in double precision ',&
-         !             &         ' please add key_mpp_rep')
 
       ! ------------------- !
Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/DOM/closea.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/DOM/closea.F90	(revision 7291)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/DOM/closea.F90	(revision 7298)
@@ -220,26 +220,15 @@
          !
          !                                        ! surface of closed seas 
-         IF( lk_mpp_rep ) THEN                         ! MPP reproductible calculation
-            DO jc = 1, jpncs
-               ctmp = CMPLX( 0.e0, 0.e0, wp )
-               DO jj = ncsj1(jc), ncsj2(jc)
-                  DO ji = ncsi1(jc), ncsi2(jc)
-                     ztmp = e1e2t(ji,jj) * tmask_i(ji,jj)
-                     CALL DDPDD( CMPLX( ztmp, 0.e0, wp ), ctmp )
-                  END DO 
-               END DO 
-               IF( lk_mpp )   CALL mpp_sum( ctmp )
-               surf(jc) = REAL(ctmp,wp)
-            END DO
-         ELSE                                          ! Standard calculation           
-            DO jc = 1, jpncs
-               DO jj = ncsj1(jc), ncsj2(jc)
-                  DO ji = ncsi1(jc), ncsi2(jc)
-                     surf(jc) = surf(jc) + e1e2t(ji,jj) * tmask_i(ji,jj)      ! surface of closed seas
-                  END DO 
+         DO jc = 1, jpncs
+            ctmp = CMPLX( 0.e0, 0.e0, wp )
+            DO jj = ncsj1(jc), ncsj2(jc)
+               DO ji = ncsi1(jc), ncsi2(jc)
+                  ztmp = e1e2t(ji,jj) * tmask_i(ji,jj)
+                  CALL DDPDD( CMPLX( ztmp, 0.e0, wp ), ctmp )
                END DO 
             END DO 
-            IF( lk_mpp )   CALL mpp_sum ( surf, jpncs )       ! mpp: sum over all the global domain
-         ENDIF
+            IF( lk_mpp )   CALL mpp_sum( ctmp )
+            surf(jc) = REAL(ctmp,wp)
+         END DO
 
          IF(lwp) WRITE(numout,*)'     Closed sea surfaces'
@@ -257,26 +246,15 @@
       !                                                   !  update emp        !
       zfwf = 0.e0_wp                                      !--------------------!
-      IF( lk_mpp_rep ) THEN                         ! MPP reproductible calculation
-         DO jc = 1, jpncs
-            ctmp = CMPLX( 0.e0, 0.e0, wp )
-            DO jj = ncsj1(jc), ncsj2(jc)
-               DO ji = ncsi1(jc), ncsi2(jc)
-                  ztmp = e1e2t(ji,jj) * ( emp(ji,jj)-rnf(ji,jj) ) * tmask_i(ji,jj)
-                  CALL DDPDD( CMPLX( ztmp, 0.e0, wp ), ctmp )
-               END DO  
-            END DO 
-            IF( lk_mpp )   CALL mpp_sum( ctmp )
-            zfwf(jc) = REAL(ctmp,wp)
-         END DO
-      ELSE                                          ! Standard calculation           
-         DO jc = 1, jpncs
-            DO jj = ncsj1(jc), ncsj2(jc)
-               DO ji = ncsi1(jc), ncsi2(jc)
-                  zfwf(jc) = zfwf(jc) + e1e2t(ji,jj) * ( emp(ji,jj)-rnf(ji,jj) ) * tmask_i(ji,jj) 
-               END DO  
-            END DO 
-         END DO
-         IF( lk_mpp )   CALL mpp_sum ( zfwf(:) , jpncs )       ! mpp: sum over all the global domain
-      ENDIF
+      DO jc = 1, jpncs
+         ctmp = CMPLX( 0.e0, 0.e0, wp )
+         DO jj = ncsj1(jc), ncsj2(jc)
+            DO ji = ncsi1(jc), ncsi2(jc)
+               ztmp = e1e2t(ji,jj) * ( emp(ji,jj)-rnf(ji,jj) ) * tmask_i(ji,jj)
+               CALL DDPDD( CMPLX( ztmp, 0.e0, wp ), ctmp )
+            END DO  
+         END DO 
+         IF( lk_mpp )   CALL mpp_sum( ctmp )
+         zfwf(jc) = REAL(ctmp,wp)
+      END DO
 
       IF( cp_cfg == "orca" .AND. jp_cfg == 2 ) THEN      ! Black Sea case for ORCA_R2 configuration
Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/DOM/dom_oce.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/DOM/dom_oce.F90	(revision 7291)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/DOM/dom_oce.F90	(revision 7298)
@@ -270,13 +270,4 @@
 
    !!----------------------------------------------------------------------
-   !! mpp reproducibility
-   !!----------------------------------------------------------------------
-#if defined key_mpp_rep
-   LOGICAL, PUBLIC, PARAMETER ::   lk_mpp_rep = .TRUE.    !: agrif flag
-#else
-   LOGICAL, PUBLIC, PARAMETER ::   lk_mpp_rep = .FALSE.   !: agrif flag
-#endif
-
-   !!----------------------------------------------------------------------
    !! agrif domain
    !!----------------------------------------------------------------------
Index: branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/lib_fortran.F90
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/lib_fortran.F90	(revision 7291)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/NEMO/OPA_SRC/lib_fortran.F90	(revision 7298)
@@ -7,4 +7,5 @@
    !!            3.4  !  2013-06  (C. Rousset)  add glob_min, glob_max 
    !!                                           + 3d dim. of input is fexible (jpk, jpl...) 
+   !!            4.0  !  2016-06  (T. Lovato)  double precision global sum by default 
    !!----------------------------------------------------------------------
 
@@ -61,149 +62,4 @@
 CONTAINS
 
-#if ! defined key_mpp_rep
-   ! --- SUM ---
-
-   FUNCTION glob_sum_1d( ptab, kdim )
-      !!-----------------------------------------------------------------------
-      !!                  ***  FUNCTION  glob_sum_1D  ***
-      !!
-      !! ** Purpose : perform a masked sum on the inner global domain of a 1D array
-      !!-----------------------------------------------------------------------
-      INTEGER :: kdim
-      REAL(wp), INTENT(in), DIMENSION(kdim) ::   ptab        ! input 1D array
-      REAL(wp)                              ::   glob_sum_1d ! global sum
-      !!-----------------------------------------------------------------------
-      !
-      glob_sum_1d = SUM( ptab(:) )
-      IF( lk_mpp )   CALL mpp_sum( glob_sum_1d )
-      !
-   END FUNCTION glob_sum_1d
-
-   FUNCTION glob_sum_2d( ptab )
-      !!-----------------------------------------------------------------------
-      !!                  ***  FUNCTION  glob_sum_2D  ***
-      !!
-      !! ** Purpose : perform a masked sum on the inner global domain of a 2D array
-      !!-----------------------------------------------------------------------
-      REAL(wp), INTENT(in), DIMENSION(:,:) ::   ptab          ! input 2D array
-      REAL(wp)                             ::   glob_sum_2d   ! global masked sum
-      !!-----------------------------------------------------------------------
-      !
-      glob_sum_2d = SUM( ptab(:,:)*tmask_i(:,:) )
-      IF( lk_mpp )   CALL mpp_sum( glob_sum_2d )
-      !
-   END FUNCTION glob_sum_2d
-
-
-   FUNCTION glob_sum_3d( ptab )
-      !!-----------------------------------------------------------------------
-      !!                  ***  FUNCTION  glob_sum_3D  ***
-      !!
-      !! ** Purpose : perform a masked sum on the inner global domain of a 3D array
-      !!-----------------------------------------------------------------------
-      REAL(wp), INTENT(in), DIMENSION(:,:,:) ::   ptab          ! input 3D array
-      REAL(wp)                               ::   glob_sum_3d   ! global masked sum
-      !!
-      INTEGER :: jk
-      INTEGER :: ijpk ! local variable: size of the 3d dimension of ptab
-      !!-----------------------------------------------------------------------
-      !
-      ijpk = SIZE(ptab,3)
-      !
-      glob_sum_3d = 0.e0
-      DO jk = 1, ijpk
-         glob_sum_3d = glob_sum_3d + SUM( ptab(:,:,jk)*tmask_i(:,:) )
-      END DO
-      IF( lk_mpp )   CALL mpp_sum( glob_sum_3d )
-      !
-   END FUNCTION glob_sum_3d
-
-
-   FUNCTION glob_sum_2d_a( ptab1, ptab2 )
-      !!-----------------------------------------------------------------------
-      !!                  ***  FUNCTION  glob_sum_2D _a ***
-      !!
-      !! ** Purpose : perform a masked sum on the inner global domain of two 2D array
-      !!-----------------------------------------------------------------------
-      REAL(wp), INTENT(in), DIMENSION(:,:) ::   ptab1, ptab2    ! input 2D array
-      REAL(wp)            , DIMENSION(2)   ::   glob_sum_2d_a   ! global masked sum
-      !!-----------------------------------------------------------------------
-      !
-      glob_sum_2d_a(1) = SUM( ptab1(:,:)*tmask_i(:,:) )
-      glob_sum_2d_a(2) = SUM( ptab2(:,:)*tmask_i(:,:) )
-      IF( lk_mpp )   CALL mpp_sum( glob_sum_2d_a, 2 )
-      !
-   END FUNCTION glob_sum_2d_a
-
-
-   FUNCTION glob_sum_3d_a( ptab1, ptab2 )
-      !!-----------------------------------------------------------------------
-      !!                  ***  FUNCTION  glob_sum_3D_a ***
-      !!
-      !! ** Purpose : perform a masked sum on the inner global domain of two 3D array
-      !!-----------------------------------------------------------------------
-      REAL(wp), INTENT(in), DIMENSION(:,:,:) ::   ptab1, ptab2    ! input 3D array
-      REAL(wp)            , DIMENSION(2)     ::   glob_sum_3d_a   ! global masked sum
-      !!
-      INTEGER :: jk
-      INTEGER :: ijpk ! local variable: size of the 3d dimension of ptab
-      !!-----------------------------------------------------------------------
-      !
-      ijpk = SIZE(ptab1,3)
-      !
-      glob_sum_3d_a(:) = 0.e0
-      DO jk = 1, ijpk
-         glob_sum_3d_a(1) = glob_sum_3d_a(1) + SUM( ptab1(:,:,jk)*tmask_i(:,:) )
-         glob_sum_3d_a(2) = glob_sum_3d_a(2) + SUM( ptab2(:,:,jk)*tmask_i(:,:) )
-      END DO
-      IF( lk_mpp )   CALL mpp_sum( glob_sum_3d_a, 2 )
-      !
-   END FUNCTION glob_sum_3d_a
-
-   FUNCTION glob_sum_full_2d( ptab )
-      !!----------------------------------------------------------------------
-      !!                  ***  FUNCTION  glob_sum_full_2d ***
-      !!
-      !! ** Purpose : perform a sum in calling DDPDD routine (nomask)
-      !!----------------------------------------------------------------------
-      REAL(wp), INTENT(in), DIMENSION(:,:) ::   ptab
-      REAL(wp)                             ::   glob_sum_full_2d   ! global sum
-      !!
-      !!-----------------------------------------------------------------------
-      !
-      glob_sum_full_2d = SUM( ptab(:,:) * tmask_h(:,:) )
-      IF( lk_mpp )   CALL mpp_sum( glob_sum_full_2d )
-      !
-   END FUNCTION glob_sum_full_2d
-
-   FUNCTION glob_sum_full_3d( ptab )
-      !!----------------------------------------------------------------------
-      !!                  ***  FUNCTION  glob_sum_full_3d ***
-      !!
-      !! ** Purpose : perform a sum on a 3D array in calling DDPDD routine (nomask)
-      !!----------------------------------------------------------------------
-      REAL(wp), INTENT(in), DIMENSION(:,:,:) ::   ptab
-      REAL(wp)                               ::   glob_sum_full_3d   ! global sum
-      !!
-      INTEGER    ::   ji, jj, jk   ! dummy loop indices
-      INTEGER    ::   ijpk ! local variables: size of ptab
-      !!-----------------------------------------------------------------------
-      !
-      ijpk = SIZE(ptab,3)
-      !
-      glob_sum_full_3d = 0.e0
-      DO jk = 1, ijpk
-         glob_sum_full_3d = glob_sum_full_3d + SUM( ptab(:,:,jk) * tmask_h(:,:) )
-      END DO
-      IF( lk_mpp )   CALL mpp_sum( glob_sum_full_3d )
-      !
-   END FUNCTION glob_sum_full_3d
-
-
-#else  
-   !!----------------------------------------------------------------------
-   !!   'key_mpp_rep'                                   MPP reproducibility
-   !!----------------------------------------------------------------------
-   
    ! --- SUM ---
    FUNCTION glob_sum_1d( ptab, kdim )
@@ -417,8 +273,4 @@
    END FUNCTION glob_sum_full_3d
 
-
-
-#endif
-
    ! --- MIN ---
    FUNCTION glob_min_2d( ptab ) 
Index: branches/2016/dev_CMCC_2016/NEMOGCM/SETTE/README
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/SETTE/README	(revision 7291)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/SETTE/README	(revision 7298)
@@ -21,5 +21,5 @@
                         -n : config name (in examples config_name_nproci_nprocj), see ./makenemo -n help
                         -r : reference configuration (if you don't give it you have to choise directories to install)
-                        add_key : to add list of keys (for example to test reproductibility: add_key mpp_rep)
+                        add_key : to add list of keys
                         del_key : to del list of keys
                and for more details and options of makenemo see ./makenemo -h
Index: branches/2016/dev_CMCC_2016/NEMOGCM/SETTE/sette.sh
===================================================================
--- branches/2016/dev_CMCC_2016/NEMOGCM/SETTE/sette.sh	(revision 7291)
+++ branches/2016/dev_CMCC_2016/NEMOGCM/SETTE/sette.sh	(revision 7298)
@@ -222,5 +222,5 @@
     export TEST_NAME="REPRO_1_4"
     cd ${CONFIG_DIR}
-    . ./makenemo -m ${CMP_NAM} -n GYRE_4 -r GYRE -j 8 add_key "key_mpp_rep" del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n GYRE_4 -r GYRE -j 8 del_key ${DEL_KEYS}
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -381,5 +381,5 @@
     export TEST_NAME="REPRO_4_4"
     cd ${CONFIG_DIR}
-    . ./makenemo -m ${CMP_NAM} -n ORCA2LIMPIS_16 -r ORCA2_LIM_PISCES -j 8 add_key "key_mpp_rep" del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n ORCA2LIMPIS_16 -r ORCA2_LIM_PISCES -j 8 del_key ${DEL_KEYS}
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -468,5 +468,5 @@
     export TEST_NAME="LONG"
     cd ${CONFIG_DIR}
-    . ./makenemo -m ${CMP_NAM} -n ORCA2OFFPIS_LONG -r ORCA2_OFF_PISCES -j 8 add_key "key_mpp_rep" del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n ORCA2OFFPIS_LONG -r ORCA2_OFF_PISCES -j 8 del_key ${DEL_KEYS}
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -555,5 +555,5 @@
     export TEST_NAME="REPRO_4_4"
     cd ${CONFIG_DIR}
-    . ./makenemo -m ${CMP_NAM} -n ORCA2OFFPIS_16 -r ORCA2_OFF_PISCES -j 8 add_key "key_mpp_rep" del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n ORCA2OFFPIS_16 -r ORCA2_OFF_PISCES -j 8 del_key ${DEL_KEYS}
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -706,5 +706,5 @@
     export TEST_NAME="REPRO_4_4"
     cd ${CONFIG_DIR}
-    . ./makenemo -m ${CMP_NAM} -n ORCA2LIM3_16 -r ORCA2_LIM3 -j 8 add_key "key_mpp_rep" del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n ORCA2LIM3_16 -r ORCA2_LIM3 -j 8 del_key ${DEL_KEYS}
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -829,5 +829,5 @@
     export TEST_NAME="REPRO_8_4"
     cd ${CONFIG_DIR}
-    . ./makenemo -m ${CMP_NAM} -n AMM12_32 -r AMM12 -j 8 add_key "key_mpp_rep key_tide" del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n AMM12_32 -r AMM12 -j 8 add_key "key_tide" del_key ${DEL_KEYS}
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -887,5 +887,5 @@
     export TEST_NAME="LONG"
     cd ${CONFIG_DIR}
-    . ./makenemo -m ${CMP_NAM} -n SAS_LONG -r ORCA2_SAS_LIM -j 8 add_key "key_mpp_rep" del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n SAS_LONG -r ORCA2_SAS_LIM -j 8 del_key ${DEL_KEYS}
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -949,5 +949,5 @@
     export TEST_NAME="REPRO_8_4"
     cd ${CONFIG_DIR}
-    . ./makenemo -m ${CMP_NAM} -n SAS_32 -r ORCA2_SAS_LIM -j 8 add_key "key_mpp_rep" del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n SAS_32 -r ORCA2_SAS_LIM -j 8 add_key del_key ${DEL_KEYS}
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -1072,5 +1072,5 @@
     export TEST_NAME="REPRO_1_4"
     cd ${CONFIG_DIR}
-    . ./makenemo -m ${CMP_NAM} -n ISOMIP_4 -u ISOMIP -j 8 add_key "key_mpp_rep" del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n ISOMIP_4 -u ISOMIP -j 8 del_key ${DEL_KEYS}
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -1137,5 +1137,5 @@
     export TEST_NAME="REPRO_4_4"
     cd ${CONFIG_DIR}
-    . ./makenemo -m ${CMP_NAM} -n ORCA2_LIM_OBS -r ORCA2_LIM -j 8 add_key "key_mpp_rep key_asminc" del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n ORCA2_LIM_OBS -r ORCA2_LIM -j 8 add_key "key_asminc" del_key ${DEL_KEYS}
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -1218,5 +1218,5 @@
     export TEST_NAME="SHORT"
     cd ${CONFIG_DIR}
-    . ./makenemo -m ${CMP_NAM} -n ORCA2AGUL_1_2 -r ORCA2_LIM -j 8 add_key "key_mpp_rep key_agrif" del_key "key_zdftmx" del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n ORCA2AGUL_1_2 -r ORCA2_LIM -j 8 add_key "key_agrif" del_key "key_zdftmx" del_key ${DEL_KEYS}
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -1258,5 +1258,5 @@
     export TEST_NAME="SHORT_NOZOOM"
     cd ${CONFIG_DIR}
-    . ./makenemo -m ${CMP_NAM} -n ORCA2AGUL_2_2 -r ORCA2_LIM -j 8 add_key "key_mpp_rep key_agrif" del_key "key_zdftmx" del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n ORCA2AGUL_2_2 -r ORCA2_LIM -j 8 add_key "key_agrif" del_key "key_zdftmx" del_key ${DEL_KEYS}
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -1291,5 +1291,5 @@
     export TEST_NAME="SHORT_NOAGRIF"
     cd ${CONFIG_DIR}
-    . ./makenemo -m ${CMP_NAM} -n ORCA2AGUL_2_2_NAG -r ORCA2_LIM -j 8 add_key "key_mpp_rep" del_key "key_zdftmx" del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n ORCA2AGUL_2_2_NAG -r ORCA2_LIM -j 8 del_key "key_zdftmx" del_key ${DEL_KEYS}
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -1325,5 +1325,5 @@
     export TEST_NAME="LONG"
     cd ${CONFIG_DIR}
-    . ./makenemo -m ${CMP_NAM} -n ORCA2AGUL_LONG -r ORCA2_LIM -j 8 add_key "key_mpp_rep key_agrif" del_key "key_zdftmx" del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n ORCA2AGUL_LONG -r ORCA2_LIM -j 8 add_key "key_agrif" del_key "key_zdftmx" del_key ${DEL_KEYS}
     cd ${SETTE_DIR}
     . ./param.cfg
@@ -1411,5 +1411,5 @@
     export TEST_NAME="REPRO_4_4"
     cd ${CONFIG_DIR}
-    . ./makenemo -m ${CMP_NAM} -n ORCA2AGUL_16 -r ORCA2_LIM -j 8 add_key "key_mpp_rep key_agrif" del_key "key_zdftmx" del_key ${DEL_KEYS}
+    . ./makenemo -m ${CMP_NAM} -n ORCA2AGUL_16 -r ORCA2_LIM -j 8 add_key "key_agrif" del_key "key_zdftmx" del_key ${DEL_KEYS}
     cd ${SETTE_DIR}
     . ./param.cfg