Index: /branches/2016/dev_r6859_LIM3_meltponds/NEMOGCM/NEMO/LIM_SRC_3/ice.F90
===================================================================
--- /branches/2016/dev_r6859_LIM3_meltponds/NEMOGCM/NEMO/LIM_SRC_3/ice.F90	(revision 7305)
+++ /branches/2016/dev_r6859_LIM3_meltponds/NEMOGCM/NEMO/LIM_SRC_3/ice.F90	(revision 7306)
@@ -281,4 +281,5 @@
    LOGICAL , PUBLIC ::   ln_limMP         !: activate melt ponds or not
    INTEGER , PUBLIC ::   nn_limMP         !: type of melt pond implementation (1=full, 2=radiation only, 3=freshwater only)
+   ! END MV MP 2016
 
    !                                     !!** some other parameters 
@@ -527,4 +528,12 @@
       ALLOCATE( t_i(jpi,jpj,nlay_i,jpl) , e_i(jpi,jpj,nlay_i,jpl) , s_i(jpi,jpj,nlay_i,jpl) , STAT=ierr(ii) )
 
+      ! MV MP 2016
+      ii = ii + 1
+      ALLOCATE( a_ip(jpi,jpj,jpl) , v_ip(jpi,jpj,jpl) , a_ip_frac(jpi,jpj,jpl) , &
+         &      h_ip(jpi,jpj,jpl) , STAT = ierr(ii) )
+      ii = ii + 1
+      ALLOCATE( at_ip(jpi,jpj) , vt_ip(jpi,jpj) , STAT = ierr(ii) )
+      ! END MV MP 2016
+
       ! * Moments for advection
       ii = ii + 1
@@ -544,4 +553,10 @@
          &      syye(jpi,jpj,nlay_i,jpl) , sxye(jpi,jpj,nlay_i,jpl)                            , STAT=ierr(ii) )
 
+      ! MV MP 2016
+      ALLOCATE( sxap(jpi,jpj,jpl) , syap(jpi,jpj,jpl) , sxxap(jpi,jpj,jpl) , syyap(jpi,jpj,jpl) , sxyap(jpi,jpj,jpl) ,   &
+         &      sxvp(jpi,jpj,jpl) , syvp(jpi,jpj,jpl) , sxxvp(jpi,jpj,jpl) , syyvp(jpi,jpj,jpl) , sxyvp(jpi,jpj,jpl) ,   &
+         &      STAT = ierr(ii) )
+      ! END MV MP 2016
+
       ! * Old values of global variables
       ii = ii + 1
Index: /branches/2016/dev_r6859_LIM3_meltponds/NEMOGCM/NEMO/LIM_SRC_3/limistate.F90
===================================================================
--- /branches/2016/dev_r6859_LIM3_meltponds/NEMOGCM/NEMO/LIM_SRC_3/limistate.F90	(revision 7305)
+++ /branches/2016/dev_r6859_LIM3_meltponds/NEMOGCM/NEMO/LIM_SRC_3/limistate.F90	(revision 7306)
@@ -474,9 +474,9 @@
       ! MV MP 2016
       IF ( ln_limMP ) THEN
-         sxap  (:,:) = 0._wp    ; sxvp  (:,:) = 0._wp 
-         syap  (:,:) = 0._wp    ; syvp  (:,:) = 0._wp 
-         sxxap (:,:) = 0._wp    ; sxxvp (:,:) = 0._wp 
-         syyap (:,:) = 0._wp    ; syyvp (:,:) = 0._wp 
-         sxyap (:,:) = 0._wp    ; sxyvp (:,:) = 0._wp
+         sxap  (:,:,:) = 0._wp    ; sxvp  (:,:,:) = 0._wp 
+         syap  (:,:,:) = 0._wp    ; syvp  (:,:,:) = 0._wp 
+         sxxap (:,:,:) = 0._wp    ; sxxvp (:,:,:) = 0._wp 
+         syyap (:,:,:) = 0._wp    ; syyvp (:,:,:) = 0._wp 
+         sxyap (:,:,:) = 0._wp    ; sxyvp (:,:,:) = 0._wp
       ENDIF
       ! END MV MP 2016
Index: /branches/2016/dev_r6859_LIM3_meltponds/NEMOGCM/NEMO/LIM_SRC_3/limrst.F90
===================================================================
--- /branches/2016/dev_r6859_LIM3_meltponds/NEMOGCM/NEMO/LIM_SRC_3/limrst.F90	(revision 7305)
+++ /branches/2016/dev_r6859_LIM3_meltponds/NEMOGCM/NEMO/LIM_SRC_3/limrst.F90	(revision 7306)
@@ -154,4 +154,5 @@
       IF ( ln_limMP ) THEN
          DO jl = 1, jpl 
+            WRITE(zchar,'(I2.2)') jl
             znam = 'a_ip'//'_htc'//zchar
             z2d(:,:) = a_ip(:,:,jl)
@@ -317,4 +318,5 @@
          IF ( ln_limMP ) THEN
             DO jl = 1, jpl 
+               WRITE(zchar,'(I2.2)') jl
                znam = 'sxap'//'_htc'//zchar
                z2d(:,:) = sxap(:,:,jl)
@@ -439,4 +441,5 @@
       IF ( ln_limMP ) THEN
          DO jl = 1, jpl 
+            WRITE(zchar,'(I2.2)') jl
             znam = 'a_ip'//'_htc'//zchar
             CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
@@ -447,4 +450,5 @@
          END DO
       ENDIF
+      ! END MV MP 2016
 
       DO jl = 1, jpl 
@@ -573,4 +577,5 @@
          IF ( ln_limMP ) THEN
             DO jl = 1, jpl 
+               WRITE(zchar,'(I2.2)') jl
                znam = 'sxap'//'_htc'//zchar
                CALL iom_get( numrir, jpdom_autoglo, znam , z2d )
Index: /branches/2016/dev_r6859_LIM3_meltponds/NEMOGCM/NEMO/LIM_SRC_3/limvar.F90
===================================================================
--- /branches/2016/dev_r6859_LIM3_meltponds/NEMOGCM/NEMO/LIM_SRC_3/limvar.F90	(revision 7305)
+++ /branches/2016/dev_r6859_LIM3_meltponds/NEMOGCM/NEMO/LIM_SRC_3/limvar.F90	(revision 7306)
@@ -92,7 +92,7 @@
 
       ! MV MP 2016
-      IF ( ln_limMP )
-         at_i_p(:,:) = SUM( a_ip, dim=3 )
-         vt_i_p(:,:) = SUM( v_ip, dim=3 )
+      IF ( ln_limMP ) THEN
+         at_ip(:,:) = SUM( a_ip, dim=3 )
+         vt_ip(:,:) = SUM( v_ip, dim=3 )
       ENDIF
       ! END MP 2016