Index: branches/2016/dev_CNRS_2016/NEMOGCM/SETTE/sette.sh
===================================================================
--- branches/2016/dev_CNRS_2016/NEMOGCM/SETTE/sette.sh	(revision 7307)
+++ branches/2016/dev_CNRS_2016/NEMOGCM/SETTE/sette.sh	(revision 7316)
@@ -370,5 +370,5 @@
         ln -sf ../LONG/O2L3P_LONG_00000075_restart_ice_${L_NPROC}.nc .
 # add for icebergs
-        ln -sf ../LONG/O2L3P_LONG_icebergs_00000075_${L_NPROC}.nc .
+        ln -sf ../LONG/O2L3P_LONG_icebergs_00000075_restart_${L_NPROC}.nc .
     done
     if [ ${USING_MPMD} == "yes" ] ; then
Index: branches/2016/dev_CNRS_2016/NEMOGCM/SETTE/sette_rpt
===================================================================
--- branches/2016/dev_CNRS_2016/NEMOGCM/SETTE/sette_rpt	(revision 7307)
+++ branches/2016/dev_CNRS_2016/NEMOGCM/SETTE/sette_rpt	(revision 7316)
@@ -86,5 +86,5 @@
   
   if ( -d ./WORCA2LIM3PIS_LONG ) then
-    set dorv = `ls -1rtd ./WORCA2LIM3PIS_LONG/{$mach}/* | tail -1l `
+    set dorv = `ls -1rtd ./WORCA2LIMPIS_LONG/{$mach}/* | tail -1l `
     set dorv = $dorv:t
     set f1o = ./WORCA2LIM3PIS_LONG/{$mach}/{$dorv}/LONG/ocean.output
@@ -195,31 +195,31 @@
     rm f1.tmp$$
   endif
-#  if ( -d ./WORCA2LIM3_LONG ) then
-#    set dorv = `ls -1rtd ./WORCA2LIM3_LONG/{$mach}/* | tail -1l `
-#    set dorv = $dorv:t
-#    set f1o = ./WORCA2LIM3_LONG/{$mach}/{$dorv}/LONG/ocean.output
-#    set f1s = ./WORCA2LIM3_LONG/{$mach}/{$dorv}/LONG/solver.stat
-#    set f2o = ./WORCA2LIM3_LONG/{$mach}/{$dorv}/SHORT/ocean.output
-#    set f2s = ./WORCA2LIM3_LONG/{$mach}/{$dorv}/SHORT/solver.stat
-#    set nl = `wc -l $f2s`
-#    tail -$nl[1] $f1s > f1.tmp$$
-#    cmp -s f1.tmp$$ $f2s
-#    if ( $status == 0 ) then
-#      echo "ORCA2LIM3   restartability  passed"
-#    else
-#      echo "ORCA2LIM3   restartability  FAILED"
-#      if ( $pass == 1 ) then
-#        echo "<return> to view solver.stat differences"
-#        set y = $<
-#        sdiff f1.tmp$$ $f2s
-#        echo "<return> to view ocean.output differences"
-#        set y = $<
-#        sdiff $f1o $f2o | grep "|"
-#        echo "<return> to continue"
-#        set y = $<
-#      endif
-#    endif
-#    rm f1.tmp$$
-#  endif
+  if ( -d ./WORCA2LIM3_LONG ) then
+    set dorv = `ls -1rtd ./WORCA2LIM3_LONG/{$mach}/* | tail -1l `
+    set dorv = $dorv:t
+    set f1o = ./WORCA2LIM3_LONG/{$mach}/{$dorv}/LONG/ocean.output
+    set f1s = ./WORCA2LIM3_LONG/{$mach}/{$dorv}/LONG/solver.stat
+    set f2o = ./WORCA2LIM3_LONG/{$mach}/{$dorv}/SHORT/ocean.output
+    set f2s = ./WORCA2LIM3_LONG/{$mach}/{$dorv}/SHORT/solver.stat
+    set nl = `wc -l $f2s`
+    tail -$nl[1] $f1s > f1.tmp$$
+    cmp -s f1.tmp$$ $f2s
+    if ( $status == 0 ) then
+      echo "ORCA2LIM3   restartability  passed"
+    else
+      echo "ORCA2LIM3   restartability  FAILED"
+      if ( $pass == 1 ) then
+        echo "<return> to view solver.stat differences"
+        set y = $<
+        sdiff f1.tmp$$ $f2s
+        echo "<return> to view ocean.output differences"
+        set y = $<
+        sdiff $f1o $f2o | grep "|"
+        echo "<return> to continue"
+        set y = $<
+      endif
+    endif
+    rm f1.tmp$$
+  endif
 
   if ( -d ./WSAS_LONG ) then
@@ -261,5 +261,5 @@
   
   if ( -d ./WGYRE_32 ) then
-    set dorv = `ls -1rtd ./WGYRE_4/{$mach}/* | tail -1l `
+    set dorv = `ls -1rtd ./WGYRE_32/{$mach}/* | tail -1l `
     set dorv = $dorv:t
     set f1o = ./WGYRE_32/{$mach}/{$dorv}/REPRO_4_8/ocean.output
@@ -287,5 +287,5 @@
 
   if ( -d ./WISOMIP_32 ) then
-    set dorv = `ls -1rtd ./WISOMIP_4/{$mach}/* | tail -1l `
+    set dorv = `ls -1rtd ./WISOMIP_32/{$mach}/* | tail -1l `
     set dorv = $dorv:t
     set f1o = ./WISOMIP_32/{$mach}/{$dorv}/REPRO_4_8/ocean.output
@@ -313,5 +313,5 @@
  
   if ( -d ./WORCA2LIM3PIS_32 ) then
-    set dorv = `ls -1rtd ./WORCA2LIMPIS_16/{$mach}/* | tail -1l `
+    set dorv = `ls -1rtd ./WORCA2LIM3PIS_32/{$mach}/* | tail -1l `
     set dorv = $dorv:t
     set f1o = ./WORCA2LIM3PIS_32/{$mach}/{$dorv}/REPRO_4_8/ocean.output
@@ -412,29 +412,29 @@
   endif
 
-#  if ( -d ./WORCA2LIM3_16 ) then
-#    set dorv = `ls -1rtd ./WORCA2LIM3_16/{$mach}/* | tail -1l `
-#    set dorv = $dorv:t
-#    set f1o = ./WORCA2LIM3_16/{$mach}/{$dorv}/REPRO_4_8/ocean.output
-#    set f1s = ./WORCA2LIM3_16/{$mach}/{$dorv}/REPRO_4_8/solver.stat
-#    set f2o = ./WORCA2LIM3_16/{$mach}/{$dorv}/REPRO_8_4/ocean.output
-#    set f2s = ./WORCA2LIM3_16/{$mach}/{$dorv}/REPRO_8_4/solver.stat
-#
-#    cmp -s $f1s $f2s
-#    if ( $status == 0 ) then
-#      echo "ORCA2LIM3   reproducibility passed"
-#    else
-#      echo "ORCA2LIM3   reproducibility FAILED"
-#      if ( $pass == 1 ) then
-#        echo "<return> to view solver.stat differences"
-#        set y = $<
-#        sdiff $f1s $f2s
-#        echo "<return> to view ocean.output differences"
-#        set y = $<
-#        sdiff $f1o $f2o | grep "|"
-#        echo "<return> to continue"
-#        set y = $<
-#      endif
-#    endif
-#  endif
+  if ( -d ./WORCA2LIM3_16 ) then
+    set dorv = `ls -1rtd ./WORCA2LIM3_16/{$mach}/* | tail -1l `
+    set dorv = $dorv:t
+    set f1o = ./WORCA2LIM3_16/{$mach}/{$dorv}/REPRO_4_8/ocean.output
+    set f1s = ./WORCA2LIM3_16/{$mach}/{$dorv}/REPRO_4_8/solver.stat
+    set f2o = ./WORCA2LIM3_16/{$mach}/{$dorv}/REPRO_8_4/ocean.output
+    set f2s = ./WORCA2LIM3_16/{$mach}/{$dorv}/REPRO_8_4/solver.stat
+
+    cmp -s $f1s $f2s
+    if ( $status == 0 ) then
+      echo "ORCA2LIM3   reproducibility passed"
+    else
+      echo "ORCA2LIM3   reproducibility FAILED"
+      if ( $pass == 1 ) then
+        echo "<return> to view solver.stat differences"
+        set y = $<
+        sdiff $f1s $f2s
+        echo "<return> to view ocean.output differences"
+        set y = $<
+        sdiff $f1o $f2o | grep "|"
+        echo "<return> to continue"
+        set y = $<
+      endif
+    endif
+  endif
 
 
@@ -442,8 +442,8 @@
     set dorv = `ls -1rtd ./WORCA2_LIM3_OBS/{$mach}/* | tail -1l `
     set dorv = $dorv:t
-    set f1o = ./WORCA2_LIM3_OBS/{$mach}/{$dorv}/REPRO_4_8/ocean.output
-    set f1s = ./WORCA2_LIM3_OBS/{$mach}/{$dorv}/REPRO_4_8/solver.stat
-    set f2o = ./WORCA2_LIM3_OBS/{$mach}/{$dorv}/REPRO_8_4/ocean.output
-    set f2s = ./WORCA2_LIM3_OBS/{$mach}/{$dorv}/REPRO_8_4/solver.stat
+    set f1o = ./WORCA2_LIM3_OBS/{$mach}/{$dorv}/REPRO_2_8/ocean.output
+    set f1s = ./WORCA2_LIM3_OBS/{$mach}/{$dorv}/REPRO_2_8/solver.stat
+    set f2o = ./WORCA2_LIM3_OBS/{$mach}/{$dorv}/REPRO_4_4/ocean.output
+    set f2s = ./WORCA2_LIM3_OBS/{$mach}/{$dorv}/REPRO_4_4/solver.stat
 
     cmp -s $f1s $f2s
Index: branches/2016/dev_CNRS_2016/NEMOGCM/SETTE/sette_rpt.sh
===================================================================
--- branches/2016/dev_CNRS_2016/NEMOGCM/SETTE/sette_rpt.sh	(revision 7307)
+++ branches/2016/dev_CNRS_2016/NEMOGCM/SETTE/sette_rpt.sh	(revision 7316)
@@ -214,5 +214,5 @@
 # Restartability test
 #
- for restart_test in WGYRE_LONG WORCA2LIM3PIS_LONG WORCA2OFFPIS_LONG WISOMIP_LONG WAMM12_LONG WSAS_LONG WORCA2AGUL_LONG
+ for restart_test in WGYRE_LONG WISOMIP_LONG WORCA2LIM3PIS_LONG WORCA2OFFPIS_LONG WAMM12_LONG WORCA2LIM3_LONG WSAS_LONG WORCA2AGUL_LONG
  do
    resttest $NEMO_VALID $restart_test $pass
@@ -221,5 +221,5 @@
 # Reproducibility tests
 #
- for repro_test in WGYRE_32 WISOMIP_32 WORCA2LIM3PIS_32 WORCA2OFFPIS_32 WAMM12_32 WORCA2_LIM3_OBS WORCA2AGUL_1_2 WORCA2AGUL_16 WORCA2AGUL_2_2_NAG
+ for repro_test in WGYRE_32 WISOMIP_32 WORCA2LIM3PIS_32 WORCA2OFFPIS_32 WAMM12_32 WORCA2LIM3_16 WORCA2_LIM3_OBS WSAS_32 WORCA2AGUL_1_2 WORCA2AGUL_16 WORCA2AGUL_2_2_NAG
  do
    reprotest $NEMO_VALID $repro_test $pass